package gssim.db.utils;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class IOUtils {

	protected static Log log = LogFactory.getLog(IOUtils.class);

	private static final int DEFAULT_BUFFER_SIZE = 4096;

	public static long copy(InputStream input, OutputStream output)
			throws IOException {
		byte[] buffer = new byte[DEFAULT_BUFFER_SIZE];
		long count = 0;
		int n = 0;
		while (-1 != (n = input.read(buffer))) {
			output.write(buffer, 0, n);
			count += n;
		}
		return count;
	}

	public static byte[] toByteArray(InputStream input) {
		ByteArrayOutputStream output = new ByteArrayOutputStream();
		byte[] byteArray = null;
		try {
			copy(input, output);
			byteArray = output.toByteArray();
		} catch (IOException ioe) {
			log.trace("Error occured while converting "
					+ "input stream to byte array", ioe);
		} finally {
			try {
				output.close();
			} catch (IOException e) {
				log.trace("Unexpected error while closing output stream", e);
			}
		}

		return byteArray;

	}
}
